<html>
<head>
<title>Ogre::RTShader::Operand Class Reference - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="inherits.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="namespaceOgre.html">Ogre</a>      </li>
      <li class="navelem"><a class="el" href="namespaceOgre_1_1RTShader.html">RTShader</a>      </li>
      <li class="navelem"><a class="el" href="classOgre_1_1RTShader_1_1Operand.html">Operand</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="summary">
<a href="#pub-types">Public Types</a> &#124;
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pub-static-methods">Static Public Member Functions</a> &#124;
<a href="#pro-attribs">Protected Attributes</a>  </div>
  <div class="headertitle">
<div class="title">Ogre::RTShader::Operand Class Reference<div class="ingroups"><a class="el" href="group__RTShader.html">RTShader</a></div></div>  </div>
</div><!--header-->
<div class="contents">
<!-- doxytag: class="Ogre::RTShader::Operand" --><!-- doxytag: inherits="Ogre::AllocatedObject" -->
<p>A class that represents a function operand (its the combination of a parameter the in/out semantic and the used fields)  
 <a href="classOgre_1_1RTShader_1_1Operand.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="OgreShaderFunctionAtom_8h_source.html">OgreShaderFunctionAtom.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for Ogre::RTShader::Operand:</div>
<div class="dyncontent">
<div class="center"><img src="classOgre_1_1RTShader_1_1Operand__inherit__graph.gif" border="0" usemap="#Ogre_1_1RTShader_1_1Operand_inherit__map" alt="Inheritance graph"/></div>
<map name="Ogre_1_1RTShader_1_1Operand_inherit__map" id="Ogre_1_1RTShader_1_1Operand_inherit__map">
<area shape="rect" id="node2" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator..." alt="" coords="15,5,169,35"/></map>
<center><span class="legend">[<a href="graph_legend.html">legend</a>]</span></center></div>

<p><a href="classOgre_1_1RTShader_1_1Operand-members.html">List of all members.</a></p>
<table class="memberdecls">
<tr><td colspan="2"><h2><a name="pub-types"></a>
Public Types</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">enum &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1Operand.html#a50ab83cea566b55ad9c66d0d93ea7e7a">OpSemantic</a> { <a class="el" href="classOgre_1_1RTShader_1_1Operand.html#a50ab83cea566b55ad9c66d0d93ea7e7aa06f81dc0c627f8bdf5cc7862a2d41a03">OPS_IN</a>, 
<a class="el" href="classOgre_1_1RTShader_1_1Operand.html#a50ab83cea566b55ad9c66d0d93ea7e7aaa9c91fcd27840fa199f466c9aa479c7a">OPS_OUT</a>, 
<a class="el" href="classOgre_1_1RTShader_1_1Operand.html#a50ab83cea566b55ad9c66d0d93ea7e7aab762072f828e74fe1d0d8f750dedb26d">OPS_INOUT</a>
 }</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">enum &#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1Operand.html#a54e58fe60624832b03f124eaeff0f5a6">OpMask</a> { <br/>
&#160;&#160;<a class="el" href="classOgre_1_1RTShader_1_1Operand.html#a54e58fe60624832b03f124eaeff0f5a6a88638ec7440dbfc7f63ea80e008cd806">OPM_ALL</a> =  1 &lt;&lt; 0, 
<a class="el" href="classOgre_1_1RTShader_1_1Operand.html#a54e58fe60624832b03f124eaeff0f5a6a3e3abdcda5f9c9a0745241845d9836fb">OPM_X</a> =  1 &lt;&lt; 1, 
<a class="el" href="classOgre_1_1RTShader_1_1Operand.html#a54e58fe60624832b03f124eaeff0f5a6aaed99f6706ee4fe26faa3525735777c4">OPM_Y</a> =  1 &lt;&lt; 2, 
<a class="el" href="classOgre_1_1RTShader_1_1Operand.html#a54e58fe60624832b03f124eaeff0f5a6a8573ab5c28dfe5cc20510abbf77bb078">OPM_Z</a> =  1 &lt;&lt; 3, 
<br/>
&#160;&#160;<a class="el" href="classOgre_1_1RTShader_1_1Operand.html#a54e58fe60624832b03f124eaeff0f5a6a367b59ffbc3bda50ac3d7fb948b8f2a3">OPM_W</a> =  1 &lt;&lt; 4
<br/>
 }</td></tr>
<tr><td colspan="2"><h2><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1Operand.html#a9a8c1c431e03992bed64d6b6b5e205e6">Operand</a> (<a class="el" href="group__RTShader.html#ga9b50e9cfcf817b897c37fc77e67f1bbf">ParameterPtr</a> parameter, <a class="el" href="classOgre_1_1RTShader_1_1Operand.html#a50ab83cea566b55ad9c66d0d93ea7e7a">Operand::OpSemantic</a> opSemantic, int opMask=<a class="el" href="classOgre_1_1RTShader_1_1Operand.html#a54e58fe60624832b03f124eaeff0f5a6a88638ec7440dbfc7f63ea80e008cd806">Operand::OPM_ALL</a>, <a class="el" href="namespaceOgre.html#af851e71354d841df7138f9877c6f5931">ushort</a> indirectionLevel=0)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Class constructor.  <a href="#a9a8c1c431e03992bed64d6b6b5e205e6"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1Operand.html#a75758b13febece03975b888e384a1d6b">Operand</a> (const <a class="el" href="classOgre_1_1RTShader_1_1Operand.html">Operand</a> &amp;rhs)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Copy constructor.  <a href="#a75758b13febece03975b888e384a1d6b"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1RTShader_1_1Operand.html">Operand</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1Operand.html#ae40b4e0d19a0b667fa794f68a7f4d323">operator=</a> (const <a class="el" href="classOgre_1_1RTShader_1_1Operand.html">Operand</a> &amp;rhs)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Copy the given <a class="el" href="classOgre_1_1RTShader_1_1Operand.html" title="A class that represents a function operand (its the combination of a parameter the in/out semantic an...">Operand</a> to this <a class="el" href="classOgre_1_1RTShader_1_1Operand.html" title="A class that represents a function operand (its the combination of a parameter the in/out semantic an...">Operand</a>.  <a href="#ae40b4e0d19a0b667fa794f68a7f4d323"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1Operand.html#a0b4cefccd74aa1ed8be0aea5c22b2378">~Operand</a> ()</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Class destructor.  <a href="#a0b4cefccd74aa1ed8be0aea5c22b2378"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">const <a class="el" href="group__RTShader.html#ga9b50e9cfcf817b897c37fc77e67f1bbf">ParameterPtr</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1Operand.html#a442fef6f47459a1b980aac782555d45d">getParameter</a> () const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the parameter object as weak reference.  <a href="#a442fef6f47459a1b980aac782555d45d"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1Operand.html#a691e3080ac0ede4822951f55d4a718b0">hasFreeFields</a> () const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns true if not all fields used.  <a href="#a691e3080ac0ede4822951f55d4a718b0"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1Operand.html#aa2566f52ef780d2db721c77d7fcdd32f">getMask</a> () const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the mask bitfield.  <a href="#aa2566f52ef780d2db721c77d7fcdd32f"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1RTShader_1_1Operand.html#a50ab83cea566b55ad9c66d0d93ea7e7a">OpSemantic</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1Operand.html#acd606928c7dcba7ed43058ee4c1b361f">getSemantic</a> () const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the operand semantic (do we read/write or both with the parameter).  <a href="#acd606928c7dcba7ed43058ee4c1b361f"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="namespaceOgre.html#af851e71354d841df7138f9877c6f5931">ushort</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1Operand.html#ae2c64f2cd91742f9d87569d6c001f5ef">getIndirectionLevel</a> () const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the level of indirection.  <a href="#ae2c64f2cd91742f9d87569d6c001f5ef"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1Operand.html#aea6fe663a7e84dd9537f095bf43a5a6d">toString</a> () const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the parameter name and the usage mask like this 'color.xyz'.  <a href="#aea6fe663a7e84dd9537f095bf43a5a6d"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a421b197ca3a38da17e2eb1531a645fa2">operator new</a> (size_t sz, const char *file, int line, const char *func)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">operator new, with debug line info  <a href="#a421b197ca3a38da17e2eb1531a645fa2"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#ac4bdf968b7b9af8a5239a27da73d5711">operator new</a> (size_t sz)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#ab78a921e54419be677839cdf15d1f0b8">operator new</a> (size_t sz, void *ptr)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">placement operator new  <a href="#ab78a921e54419be677839cdf15d1f0b8"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a4be37baef81876985aa1071ad5acc6dd">operator new[]</a> (size_t sz, const char *file, int line, const char *func)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">array operator new, with debug line info  <a href="#a4be37baef81876985aa1071ad5acc6dd"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#afa2943846ba6a2b5824a12857139cf5e">operator new[]</a> (size_t sz)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a8357fe4fb4849772b94baa4bf47c7ded">operator delete</a> (void *ptr)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a1c727e879a260c37b00ce5505fe8e144">operator delete</a> (void *ptr, void *)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#acb46d4b0a597156d9ba5abc39d127792">operator delete</a> (void *ptr, const char *, int, const char *)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a93e6a86dde5483c053ca0f2a85bbfd6c">operator delete[]</a> (void *ptr)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a595ea4c05da8aa987d3800e65d23355d">operator delete[]</a> (void *ptr, const char *, int, const char *)</td></tr>
<tr><td colspan="2"><h2><a name="pub-static-methods"></a>
Static Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1Operand.html#adfd335f56221e23e5c3b0b5b2cc4a2a5">getMaskAsString</a> (int mask)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the given mask as string representation.  <a href="#adfd335f56221e23e5c3b0b5b2cc4a2a5"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1Operand.html#a0ca5992904d58fc9b98d03fe94482e75">getFloatCount</a> (int mask)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Return the float count of the given mask.  <a href="#a0ca5992904d58fc9b98d03fe94482e75"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">static <a class="el" href="group__Materials.html#ga9c5b2950be06ff56a6ee0bace240d447">GpuConstantType</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1Operand.html#a0bb486f15c8095ff4184ec23c3d6c1dc">getGpuConstantType</a> (int mask)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Return the gpu constant type of the given mask.  <a href="#a0bb486f15c8095ff4184ec23c3d6c1dc"></a><br/></td></tr>
<tr><td colspan="2"><h2><a name="pro-attribs"></a>
Protected Attributes</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__RTShader.html#ga9b50e9cfcf817b897c37fc77e67f1bbf">ParameterPtr</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1Operand.html#ac4a9c9955226d83dc5cb549ad4428b54">mParameter</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1RTShader_1_1Operand.html#a50ab83cea566b55ad9c66d0d93ea7e7a">OpSemantic</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1Operand.html#a2c7730bd7b91343e449de81d45c33eda">mSemantic</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">The parameter being carried by the operand.  <a href="#a2c7730bd7b91343e449de81d45c33eda"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1Operand.html#aac755a994405d1ac3e3777898b0fb407">mMask</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Tells if the parameter is of type input,output or both.  <a href="#aac755a994405d1ac3e3777898b0fb407"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="namespaceOgre.html#af851e71354d841df7138f9877c6f5931">ushort</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1RTShader_1_1Operand.html#a14fd9b8061396b69d145128f42b57269">mIndirectionLevel</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Which part of the parameter should be passed (x,y,z,w)  <a href="#a14fd9b8061396b69d145128f42b57269"></a><br/></td></tr>
</table>
<hr/><a name="details" id="details"></a><h2>Detailed Description</h2>
<div class="textblock"><p>A class that represents a function operand (its the combination of a parameter the in/out semantic and the used fields) </p>

<p>Definition at line <a class="el" href="OgreShaderFunctionAtom_8h_source.html#l00078">78</a> of file <a class="el" href="OgreShaderFunctionAtom_8h_source.html">OgreShaderFunctionAtom.h</a>.</p>
</div><hr/><h2>Member Enumeration Documentation</h2>
<a class="anchor" id="a54e58fe60624832b03f124eaeff0f5a6"></a><!-- doxytag: member="Ogre::RTShader::Operand::OpMask" ref="a54e58fe60624832b03f124eaeff0f5a6" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">enum <a class="el" href="classOgre_1_1RTShader_1_1Operand.html#a54e58fe60624832b03f124eaeff0f5a6">Ogre::RTShader::Operand::OpMask</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<dl><dt><b>Enumerator: </b></dt><dd><table border="0" cellspacing="2" cellpadding="0">
<tr><td valign="top"><em><a class="anchor" id="a54e58fe60624832b03f124eaeff0f5a6a88638ec7440dbfc7f63ea80e008cd806"></a><!-- doxytag: member="OPM_ALL" ref="a54e58fe60624832b03f124eaeff0f5a6a88638ec7440dbfc7f63ea80e008cd806" args="" -->OPM_ALL</em>&nbsp;</td><td>
</td></tr>
<tr><td valign="top"><em><a class="anchor" id="a54e58fe60624832b03f124eaeff0f5a6a3e3abdcda5f9c9a0745241845d9836fb"></a><!-- doxytag: member="OPM_X" ref="a54e58fe60624832b03f124eaeff0f5a6a3e3abdcda5f9c9a0745241845d9836fb" args="" -->OPM_X</em>&nbsp;</td><td>
</td></tr>
<tr><td valign="top"><em><a class="anchor" id="a54e58fe60624832b03f124eaeff0f5a6aaed99f6706ee4fe26faa3525735777c4"></a><!-- doxytag: member="OPM_Y" ref="a54e58fe60624832b03f124eaeff0f5a6aaed99f6706ee4fe26faa3525735777c4" args="" -->OPM_Y</em>&nbsp;</td><td>
</td></tr>
<tr><td valign="top"><em><a class="anchor" id="a54e58fe60624832b03f124eaeff0f5a6a8573ab5c28dfe5cc20510abbf77bb078"></a><!-- doxytag: member="OPM_Z" ref="a54e58fe60624832b03f124eaeff0f5a6a8573ab5c28dfe5cc20510abbf77bb078" args="" -->OPM_Z</em>&nbsp;</td><td>
</td></tr>
<tr><td valign="top"><em><a class="anchor" id="a54e58fe60624832b03f124eaeff0f5a6a367b59ffbc3bda50ac3d7fb948b8f2a3"></a><!-- doxytag: member="OPM_W" ref="a54e58fe60624832b03f124eaeff0f5a6a367b59ffbc3bda50ac3d7fb948b8f2a3" args="" -->OPM_W</em>&nbsp;</td><td>
</td></tr>
</table>
</dd>
</dl>

<p>Definition at line <a class="el" href="OgreShaderFunctionAtom_8h_source.html#l00094">94</a> of file <a class="el" href="OgreShaderFunctionAtom_8h_source.html">OgreShaderFunctionAtom.h</a>.</p>

</div>
</div>
<a class="anchor" id="a50ab83cea566b55ad9c66d0d93ea7e7a"></a><!-- doxytag: member="Ogre::RTShader::Operand::OpSemantic" ref="a50ab83cea566b55ad9c66d0d93ea7e7a" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">enum <a class="el" href="classOgre_1_1RTShader_1_1Operand.html#a50ab83cea566b55ad9c66d0d93ea7e7a">Ogre::RTShader::Operand::OpSemantic</a></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<dl><dt><b>Enumerator: </b></dt><dd><table border="0" cellspacing="2" cellpadding="0">
<tr><td valign="top"><em><a class="anchor" id="a50ab83cea566b55ad9c66d0d93ea7e7aa06f81dc0c627f8bdf5cc7862a2d41a03"></a><!-- doxytag: member="OPS_IN" ref="a50ab83cea566b55ad9c66d0d93ea7e7aa06f81dc0c627f8bdf5cc7862a2d41a03" args="" -->OPS_IN</em>&nbsp;</td><td>
<p>The parameter is a input parameter. </p>
</td></tr>
<tr><td valign="top"><em><a class="anchor" id="a50ab83cea566b55ad9c66d0d93ea7e7aaa9c91fcd27840fa199f466c9aa479c7a"></a><!-- doxytag: member="OPS_OUT" ref="a50ab83cea566b55ad9c66d0d93ea7e7aaa9c91fcd27840fa199f466c9aa479c7a" args="" -->OPS_OUT</em>&nbsp;</td><td>
<p>The parameter is a output parameter. </p>
</td></tr>
<tr><td valign="top"><em><a class="anchor" id="a50ab83cea566b55ad9c66d0d93ea7e7aab762072f828e74fe1d0d8f750dedb26d"></a><!-- doxytag: member="OPS_INOUT" ref="a50ab83cea566b55ad9c66d0d93ea7e7aab762072f828e74fe1d0d8f750dedb26d" args="" -->OPS_INOUT</em>&nbsp;</td><td>
<p>The parameter is a input/output parameter. </p>
</td></tr>
</table>
</dd>
</dl>

<p>Definition at line <a class="el" href="OgreShaderFunctionAtom_8h_source.html#l00083">83</a> of file <a class="el" href="OgreShaderFunctionAtom_8h_source.html">OgreShaderFunctionAtom.h</a>.</p>

</div>
</div>
<hr/><h2>Constructor &amp; Destructor Documentation</h2>
<a class="anchor" id="a9a8c1c431e03992bed64d6b6b5e205e6"></a><!-- doxytag: member="Ogre::RTShader::Operand::Operand" ref="a9a8c1c431e03992bed64d6b6b5e205e6" args="(ParameterPtr parameter, Operand::OpSemantic opSemantic, int opMask=Operand::OPM_ALL, ushort indirectionLevel=0)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1RTShader_1_1Operand.html#a9a8c1c431e03992bed64d6b6b5e205e6">Ogre::RTShader::Operand::Operand</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="group__RTShader.html#ga9b50e9cfcf817b897c37fc77e67f1bbf">ParameterPtr</a>&#160;</td>
          <td class="paramname"><em>parameter</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1RTShader_1_1Operand.html#a50ab83cea566b55ad9c66d0d93ea7e7a">Operand::OpSemantic</a>&#160;</td>
          <td class="paramname"><em>opSemantic</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>opMask</em> = <code><a class="el" href="classOgre_1_1RTShader_1_1Operand.html#a54e58fe60624832b03f124eaeff0f5a6a88638ec7440dbfc7f63ea80e008cd806">Operand::OPM_ALL</a></code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#af851e71354d841df7138f9877c6f5931">ushort</a>&#160;</td>
          <td class="paramname"><em>indirectionLevel</em> = <code>0</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Class constructor. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">parameter</td><td>A function parameter. </td></tr>
    <tr><td class="paramname">opSemantic</td><td>The in/out semantic of the parameter. </td></tr>
    <tr><td class="paramname">opMask</td><td>The field mask of the parameter. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a75758b13febece03975b888e384a1d6b"></a><!-- doxytag: member="Ogre::RTShader::Operand::Operand" ref="a75758b13febece03975b888e384a1d6b" args="(const Operand &amp;rhs)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1RTShader_1_1Operand.html#a9a8c1c431e03992bed64d6b6b5e205e6">Ogre::RTShader::Operand::Operand</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1RTShader_1_1Operand.html">Operand</a> &amp;&#160;</td>
          <td class="paramname"><em>rhs</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Copy constructor. </p>

</div>
</div>
<a class="anchor" id="a0b4cefccd74aa1ed8be0aea5c22b2378"></a><!-- doxytag: member="Ogre::RTShader::Operand::~Operand" ref="a0b4cefccd74aa1ed8be0aea5c22b2378" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1RTShader_1_1Operand.html#a0b4cefccd74aa1ed8be0aea5c22b2378">Ogre::RTShader::Operand::~Operand</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Class destructor. </p>

</div>
</div>
<hr/><h2>Member Function Documentation</h2>
<a class="anchor" id="a0ca5992904d58fc9b98d03fe94482e75"></a><!-- doxytag: member="Ogre::RTShader::Operand::getFloatCount" ref="a0ca5992904d58fc9b98d03fe94482e75" args="(int mask)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static int <a class="el" href="classOgre_1_1RTShader_1_1Operand.html#a0ca5992904d58fc9b98d03fe94482e75">Ogre::RTShader::Operand::getFloatCount</a> </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>mask</em></td><td>)</td>
          <td><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Return the float count of the given mask. </p>

</div>
</div>
<a class="anchor" id="a0bb486f15c8095ff4184ec23c3d6c1dc"></a><!-- doxytag: member="Ogre::RTShader::Operand::getGpuConstantType" ref="a0bb486f15c8095ff4184ec23c3d6c1dc" args="(int mask)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static <a class="el" href="group__Materials.html#ga9c5b2950be06ff56a6ee0bace240d447">GpuConstantType</a> <a class="el" href="classOgre_1_1RTShader_1_1Operand.html#a0bb486f15c8095ff4184ec23c3d6c1dc">Ogre::RTShader::Operand::getGpuConstantType</a> </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>mask</em></td><td>)</td>
          <td><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Return the gpu constant type of the given mask. </p>

</div>
</div>
<a class="anchor" id="ae2c64f2cd91742f9d87569d6c001f5ef"></a><!-- doxytag: member="Ogre::RTShader::Operand::getIndirectionLevel" ref="ae2c64f2cd91742f9d87569d6c001f5ef" args="() const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="namespaceOgre.html#af851e71354d841df7138f9877c6f5931">ushort</a> <a class="el" href="classOgre_1_1RTShader_1_1Operand.html#ae2c64f2cd91742f9d87569d6c001f5ef">Ogre::RTShader::Operand::getIndirectionLevel</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Returns the level of indirection. </p>
<p>The greater the indirection level the more the parameter needs to be nested in brackets. For example given 4 parameters x1...x4 with the indirections levels 0,1,1,2 respectively. The parameters should form the following string: x1[x2][x3[x4]]. </p>

<p>Definition at line <a class="el" href="OgreShaderFunctionAtom_8h_source.html#l00138">138</a> of file <a class="el" href="OgreShaderFunctionAtom_8h_source.html">OgreShaderFunctionAtom.h</a>.</p>

</div>
</div>
<a class="anchor" id="aa2566f52ef780d2db721c77d7fcdd32f"></a><!-- doxytag: member="Ogre::RTShader::Operand::getMask" ref="aa2566f52ef780d2db721c77d7fcdd32f" args="() const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int <a class="el" href="classOgre_1_1RTShader_1_1Operand.html#aa2566f52ef780d2db721c77d7fcdd32f">Ogre::RTShader::Operand::getMask</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Returns the mask bitfield. </p>

<p>Definition at line <a class="el" href="OgreShaderFunctionAtom_8h_source.html#l00128">128</a> of file <a class="el" href="OgreShaderFunctionAtom_8h_source.html">OgreShaderFunctionAtom.h</a>.</p>

</div>
</div>
<a class="anchor" id="adfd335f56221e23e5c3b0b5b2cc4a2a5"></a><!-- doxytag: member="Ogre::RTShader::Operand::getMaskAsString" ref="adfd335f56221e23e5c3b0b5b2cc4a2a5" args="(int mask)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">static <a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="el" href="classOgre_1_1RTShader_1_1Operand.html#adfd335f56221e23e5c3b0b5b2cc4a2a5">Ogre::RTShader::Operand::getMaskAsString</a> </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>mask</em></td><td>)</td>
          <td><code> [static]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Returns the given mask as string representation. </p>

</div>
</div>
<a class="anchor" id="a442fef6f47459a1b980aac782555d45d"></a><!-- doxytag: member="Ogre::RTShader::Operand::getParameter" ref="a442fef6f47459a1b980aac782555d45d" args="() const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const <a class="el" href="group__RTShader.html#ga9b50e9cfcf817b897c37fc77e67f1bbf">ParameterPtr</a>&amp; <a class="el" href="classOgre_1_1RTShader_1_1Operand.html#a442fef6f47459a1b980aac782555d45d">Ogre::RTShader::Operand::getParameter</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Returns the parameter object as weak reference. </p>

<p>Definition at line <a class="el" href="OgreShaderFunctionAtom_8h_source.html#l00122">122</a> of file <a class="el" href="OgreShaderFunctionAtom_8h_source.html">OgreShaderFunctionAtom.h</a>.</p>

</div>
</div>
<a class="anchor" id="acd606928c7dcba7ed43058ee4c1b361f"></a><!-- doxytag: member="Ogre::RTShader::Operand::getSemantic" ref="acd606928c7dcba7ed43058ee4c1b361f" args="() const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1RTShader_1_1Operand.html#a50ab83cea566b55ad9c66d0d93ea7e7a">OpSemantic</a> <a class="el" href="classOgre_1_1RTShader_1_1Operand.html#acd606928c7dcba7ed43058ee4c1b361f">Ogre::RTShader::Operand::getSemantic</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Returns the operand semantic (do we read/write or both with the parameter). </p>

<p>Definition at line <a class="el" href="OgreShaderFunctionAtom_8h_source.html#l00131">131</a> of file <a class="el" href="OgreShaderFunctionAtom_8h_source.html">OgreShaderFunctionAtom.h</a>.</p>

</div>
</div>
<a class="anchor" id="a691e3080ac0ede4822951f55d4a718b0"></a><!-- doxytag: member="Ogre::RTShader::Operand::hasFreeFields" ref="a691e3080ac0ede4822951f55d4a718b0" args="() const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classOgre_1_1RTShader_1_1Operand.html#a691e3080ac0ede4822951f55d4a718b0">Ogre::RTShader::Operand::hasFreeFields</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Returns true if not all fields used. </p>
<p>(usage is described through semantic) </p>

<p>Definition at line <a class="el" href="OgreShaderFunctionAtom_8h_source.html#l00125">125</a> of file <a class="el" href="OgreShaderFunctionAtom_8h_source.html">OgreShaderFunctionAtom.h</a>.</p>

</div>
</div>
<a class="anchor" id="a8357fe4fb4849772b94baa4bf47c7ded"></a><!-- doxytag: member="Ogre::RTShader::Operand::operator delete" ref="a8357fe4fb4849772b94baa4bf47c7ded" args="(void *ptr)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00095">95</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a1c727e879a260c37b00ce5505fe8e144"></a><!-- doxytag: member="Ogre::RTShader::Operand::operator delete" ref="a1c727e879a260c37b00ce5505fe8e144" args="(void *ptr, void *)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname">&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00101">101</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="acb46d4b0a597156d9ba5abc39d127792"></a><!-- doxytag: member="Ogre::RTShader::Operand::operator delete" ref="acb46d4b0a597156d9ba5abc39d127792" args="(void *ptr, const char *, int, const char *)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname">&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00107">107</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a93e6a86dde5483c053ca0f2a85bbfd6c"></a><!-- doxytag: member="Ogre::RTShader::Operand::operator delete[]" ref="a93e6a86dde5483c053ca0f2a85bbfd6c" args="(void *ptr)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete[] </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00112">112</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a595ea4c05da8aa987d3800e65d23355d"></a><!-- doxytag: member="Ogre::RTShader::Operand::operator delete[]" ref="a595ea4c05da8aa987d3800e65d23355d" args="(void *ptr, const char *, int, const char *)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete[] </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname">&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00118">118</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a421b197ca3a38da17e2eb1531a645fa2"></a><!-- doxytag: member="Ogre::RTShader::Operand::operator new" ref="a421b197ca3a38da17e2eb1531a645fa2" args="(size_t sz, const char *file, int line, const char *func)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>file</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>line</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>func</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>operator new, with debug line info </p>

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00067">67</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="ac4bdf968b7b9af8a5239a27da73d5711"></a><!-- doxytag: member="Ogre::RTShader::Operand::operator new" ref="ac4bdf968b7b9af8a5239a27da73d5711" args="(size_t sz)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00072">72</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="ab78a921e54419be677839cdf15d1f0b8"></a><!-- doxytag: member="Ogre::RTShader::Operand::operator new" ref="ab78a921e54419be677839cdf15d1f0b8" args="(size_t sz, void *ptr)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>placement operator new </p>

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00078">78</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a4be37baef81876985aa1071ad5acc6dd"></a><!-- doxytag: member="Ogre::RTShader::Operand::operator new[]" ref="a4be37baef81876985aa1071ad5acc6dd" args="(size_t sz, const char *file, int line, const char *func)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new[] </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>file</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>line</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>func</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>array operator new, with debug line info </p>

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00085">85</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="afa2943846ba6a2b5824a12857139cf5e"></a><!-- doxytag: member="Ogre::RTShader::Operand::operator new[]" ref="afa2943846ba6a2b5824a12857139cf5e" args="(size_t sz)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new[] </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00090">90</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="ae40b4e0d19a0b667fa794f68a7f4d323"></a><!-- doxytag: member="Ogre::RTShader::Operand::operator=" ref="ae40b4e0d19a0b667fa794f68a7f4d323" args="(const Operand &amp;rhs)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1RTShader_1_1Operand.html">Operand</a>&amp; Ogre::RTShader::Operand::operator= </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1RTShader_1_1Operand.html">Operand</a> &amp;&#160;</td>
          <td class="paramname"><em>rhs</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Copy the given <a class="el" href="classOgre_1_1RTShader_1_1Operand.html" title="A class that represents a function operand (its the combination of a parameter the in/out semantic an...">Operand</a> to this <a class="el" href="classOgre_1_1RTShader_1_1Operand.html" title="A class that represents a function operand (its the combination of a parameter the in/out semantic an...">Operand</a>. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">rhs</td><td>The other <a class="el" href="classOgre_1_1RTShader_1_1Operand.html" title="A class that represents a function operand (its the combination of a parameter the in/out semantic an...">Operand</a> to copy to this state. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="aea6fe663a7e84dd9537f095bf43a5a6d"></a><!-- doxytag: member="Ogre::RTShader::Operand::toString" ref="aea6fe663a7e84dd9537f095bf43a5a6d" args="() const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="el" href="classOgre_1_1RTShader_1_1Operand.html#aea6fe663a7e84dd9537f095bf43a5a6d">Ogre::RTShader::Operand::toString</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Returns the parameter name and the usage mask like this 'color.xyz'. </p>

</div>
</div>
<hr/><h2>Member Data Documentation</h2>
<a class="anchor" id="a14fd9b8061396b69d145128f42b57269"></a><!-- doxytag: member="Ogre::RTShader::Operand::mIndirectionLevel" ref="a14fd9b8061396b69d145128f42b57269" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="namespaceOgre.html#af851e71354d841df7138f9877c6f5931">ushort</a> <a class="el" href="classOgre_1_1RTShader_1_1Operand.html#a14fd9b8061396b69d145128f42b57269">Ogre::RTShader::Operand::mIndirectionLevel</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Which part of the parameter should be passed (x,y,z,w) </p>

<p>Definition at line <a class="el" href="OgreShaderFunctionAtom_8h_source.html#l00156">156</a> of file <a class="el" href="OgreShaderFunctionAtom_8h_source.html">OgreShaderFunctionAtom.h</a>.</p>

</div>
</div>
<a class="anchor" id="aac755a994405d1ac3e3777898b0fb407"></a><!-- doxytag: member="Ogre::RTShader::Operand::mMask" ref="aac755a994405d1ac3e3777898b0fb407" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int <a class="el" href="classOgre_1_1RTShader_1_1Operand.html#aac755a994405d1ac3e3777898b0fb407">Ogre::RTShader::Operand::mMask</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Tells if the parameter is of type input,output or both. </p>

<p>Definition at line <a class="el" href="OgreShaderFunctionAtom_8h_source.html#l00155">155</a> of file <a class="el" href="OgreShaderFunctionAtom_8h_source.html">OgreShaderFunctionAtom.h</a>.</p>

</div>
</div>
<a class="anchor" id="ac4a9c9955226d83dc5cb549ad4428b54"></a><!-- doxytag: member="Ogre::RTShader::Operand::mParameter" ref="ac4a9c9955226d83dc5cb549ad4428b54" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__RTShader.html#ga9b50e9cfcf817b897c37fc77e67f1bbf">ParameterPtr</a> <a class="el" href="classOgre_1_1RTShader_1_1Operand.html#ac4a9c9955226d83dc5cb549ad4428b54">Ogre::RTShader::Operand::mParameter</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreShaderFunctionAtom_8h_source.html#l00153">153</a> of file <a class="el" href="OgreShaderFunctionAtom_8h_source.html">OgreShaderFunctionAtom.h</a>.</p>

</div>
</div>
<a class="anchor" id="a2c7730bd7b91343e449de81d45c33eda"></a><!-- doxytag: member="Ogre::RTShader::Operand::mSemantic" ref="a2c7730bd7b91343e449de81d45c33eda" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1RTShader_1_1Operand.html#a50ab83cea566b55ad9c66d0d93ea7e7a">OpSemantic</a> <a class="el" href="classOgre_1_1RTShader_1_1Operand.html#a2c7730bd7b91343e449de81d45c33eda">Ogre::RTShader::Operand::mSemantic</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>The parameter being carried by the operand. </p>

<p>Definition at line <a class="el" href="OgreShaderFunctionAtom_8h_source.html#l00154">154</a> of file <a class="el" href="OgreShaderFunctionAtom_8h_source.html">OgreShaderFunctionAtom.h</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="OgreShaderFunctionAtom_8h_source.html">OgreShaderFunctionAtom.h</a></li>
</ul>
</div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:49:31
</p>
</body>
</html>
